## deepin-anything 7.0.22

=== src/searcher/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(deepin-anything-searcher)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Find required packages
find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(LUCENE REQUIRED liblucene++)
pkg_check_modules(LUCENE_CONTRIB REQUIRED liblucene++-contrib)
find_package(Threads REQUIRED)
find_package(Boost REQUIRED COMPONENTS system)

# Add executable
add_executable(deepin-anything-searcher
    main.cpp
    searcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../server/src/analyzers/chineseanalyzer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../server/src/analyzers/chinesetokenizer.cpp
)

# Include directories
target_include_directories(deepin-anything-searcher PRIVATE
    ${GLIB_INCLUDE_DIRS}
    ${LUCENE_INCLUDE_DIRS}
    ${LUCENE_CONTRIB_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../server/include
)

# Link libraries
target_link_libraries(deepin-anything-searcher
    ${GLIB_LIBRARIES}
    ${LUCENE_LIBRARIES}
    ${LUCENE_CONTRIB_LIBRARIES}
    Threads::Threads
    ${Boost_LIBRARIES}
)

# Install
install(TARGETS deepin-anything-searcher
    RUNTIME DESTINATION bin
)

=== src/server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# ---------------------------------------------------------------------------------------
# Start deepin-anything-daemon project
# ---------------------------------------------------------------------------------------
project(
    deepin-anything-daemon
    VERSION 1.0.0
    DESCRIPTION "A file search engine"
    LANGUAGES CXX
)

# Find the dependencies
find_package(QT NAMES Qt6 Qt5 CONFIG REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} CONFIG REQUIRED Core)
find_package(PkgConfig REQUIRED)
find_package(Boost REQUIRED COMPONENTS system)
find_package(spdlog REQUIRED)
pkg_check_modules(GNL REQUIRED libnl-3.0 libnl-genl-3.0)
pkg_check_modules(MOUNT REQUIRED mount IMPORTED_TARGET)
pkg_check_modules(LUCENE REQUIRED liblucene++)
pkg_check_modules(LUCENE_CONTRIB REQUIRED liblucene++-contrib)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(GMODULE REQUIRED gmodule-2.0)

# Found all source files
file(GLOB_RECURSE SOURCE_FILES "${PROJECT_SOURCE_DIR}/src/*.cpp" "${PROJECT_SOURCE_DIR}/src/*.c")
list(LENGTH SOURCE_FILES SRC_FILES_SIZE)
message(STATUS "Found ${SRC_FILES_SIZE} source files of deepin-anything-daemon")
foreach(source_file ${SOURCE_FILES})
    message(STATUS "  ${source_file}")
endforeach()

# Define a shared library
add_executable(${PROJECT_NAME})

target_sources(${PROJECT_NAME} PRIVATE ${SOURCE_FILES})

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../kernelmod>
    # $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../3rdparty>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    ${LUCENE_INCLUDE_DIRS}
    ${GNL_INCLUDE_DIRS}
    ${MOUNT_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${GMODULE_INCLUDE_DIRS}
    ${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PUBLIC
    ${LUCENE_LIBRARIES}
    ${LUCENE_CONTRIB_LIBRARIES}
    ${GNL_LIBRARIES}
    ${MOUNT_LIBRARIES}
    ${Boost_LIBRARIES}
    pthread
    stdc++fs
    spdlog::spdlog
    ${GLIB_LIBRARIES}
    ${GIO_LIBRARIES}
    ${GMODULE_LIBRARIES}
    Qt${QT_VERSION_MAJOR}::Core
)

target_compile_options(${PROJECT_NAME} PRIVATE -Wall -Werror -Wextra)
target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_17)

configure_file ("${PROJECT_NAME}.pc.in" "${PROJECT_NAME}.pc" @ONLY)
install(TARGETS ${PROJECT_NAME}
    COMPONENT linapp
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    DESTINATION lib
)

install(PROGRAMS deepin-anything-server DESTINATION bin)
install(FILES deepin-anything-daemon.service DESTINATION lib/systemd/user)
# installed by debhelper
# install(FILES deepin-anything-server.service DESTINATION lib/systemd/system)

# Install dconfig meta file
install(FILES ${CMAKE_SOURCE_DIR}/assets/org.deepin.anything.json DESTINATION share/dsg/configs/org.deepin.anything)

=== examples/deepin-anything-monitor/src/preloadplugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Kingtous <me@kingtous.cn>
#
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.1)

set(PRELOAD_LIB_NAME dtkqml-${CMAKE_PROJECT_NAME}-Preload)

###! 请确保 preloadplugin 下仅依赖最少的三方内容，
###! 且不做额外的复杂操作，将第三方库和自定义类型放在
###! maincomponentplugin 中，保证程序能够快速启动。
# Set sources
set(PRELOAD_SRC
    preloadplugin.cpp
    )

# Find the Qt5Quick library
find_package(Qt5Quick CONFIG REQUIRED)
find_package(Qt5QuickCompiler REQUIRED)

qtquick_compiler_add_resources(PRELOAD_RCC_SOURCES preload.qrc)

# 保证 preloadplugin 目录下头文件全局可见
include_directories(src/preloadplugin)

# Add LIB
add_library(${PRELOAD_LIB_NAME} SHARED
    ${PRELOAD_SRC}
    ${PRELOAD_RCC_SOURCES}
    )

# 由于 LIB 程序为本项目的功能实现部分，需要用到的第三方库都需要在此处添加。
target_link_libraries(${PRELOAD_LIB_NAME}
    Qt5::Quick
    ${DtkDeclarative_LIBRARIES}
    )

# Add install rule
install(TARGETS ${PRELOAD_LIB_NAME} DESTINATION ${DTK_QML_APP_PLUGIN_PATH})

=== debian/changelog ===
deepin-anything (7.0.22) unstable; urgency=medium

  * feat: Adapt to V20
  * fix: Fix index updates not saved after a timeout

 -- wangrong <wangrong@uniontech.com>  Tue, 24 Jun 2025 19:21:09 +0800

deepin-anything (7.0.21) unstable; urgency=medium

  * fix: Fix anything repeatedly restart when shutdown

 -- wangrong <wangrong@uniontech.com>  Sat, 21 Jun 2025 23:38:08 +0800

deepin-anything (7.0.20) unstable; urgency=medium

  * feat: Add configurable index commit timeouts
  * chore: Remove deepin-anything-dkms dependency
  * fix: Fix anything repeatedly restart when shutdown
  * feat: Add wildcard search functionality
  * fix: Improve blacklist path checking logic

 -- wangrong <wangrong@uniontech.com>  Thu, 19 Jun 2025 13:40:32 +0800

deepin-anything (7.0.19) unstable; urgency=medium

  * feat: Adapt kernel module for LOONGARCH architecture
  * feat: Optimize recoginizing ARM
  * feat: add support for s360x, ppc64le and riscv
  * feat: Not compile kernel module when in-tree ones already exist
  * feat: Add support for SW64 architecture in argument extraction
  * fix: Fix kernel Oops on SW64

 -- wangrong <wangrong@uniontech.com>  Thu, 29 May 2025 21:22:31 +0800

deepin-anything (7.0.18) unstable; urgency=medium

  * fix: Fix fail to update index for dir rename

 -- wangrong <wangrong@uniontech.com>  Fri, 23 May 2025 16:58:37 +0800

deepin-anything (7.0.17) unstable; urgency=medium

  * fix: Fix scan "/" crash

 -- wangrong <wangrong@uniontech.com>  Thu, 22 May 2025 16:24:31 +0800

deepin-anything (7.0.16) unstable; urgency=medium

  * fix: Enhance error handling in file index management
  * refactor: Remove unused index change filter functionality
  * refactor: Remove QStringList and QString
  * fix: Fix incorrect index traversal in the specified directory
  * feat: Check index corrupted in runtime
  * refactor: Using separate thread for event handling
  * feat: Set the maximum socket receive buffer size
  * fix: Improve event listening error handling

 -- wangrong <wangrong@uniontech.com>  Thu, 22 May 2025 11:22:31 +0800

deepin-anything (7.0.15) unstable; urgency=medium

  * fix: Improve filesystem existence checks with error handling
  * refactor: Improve event path conflict detection
  * fix: Continue receiving events after fail

 -- wangrong <wangrong@uniontech.com>  Fri, 16 May 2025 16:50:56 +0800

=== debian/control ===
Source: deepin-anything
Section: admin
Priority: optional
Maintainer: Deepin Package Builder <packages@deepin.com>
Build-Depends:
  cmake,
  debhelper (>= 10),
  dh-dkms | dkms,
  qt6-base-dev | qtbase5-dev,
  pkg-config,
  libnl-genl-3-dev,
  liblucene++-dev,
  libmount-dev,
  libboost-filesystem-dev,
  libspdlog-dev,
  libglib2.0-dev,
Standards-Version: 3.9.8
Homepage: http://github.com/linuxdeepin/deepin-anything

Package: deepin-anything-dkms
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms
Description: anything module
 anything kernel module package

Package: deepin-anything-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Anything server package
 This is the server part of Deepin Anything, which includes core functionality for the application.

## deepin-anything 7.0.23

=== src/server/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,51 @@
     DESCRIPTION "A file search engine"
     LANGUAGES CXX
 )
+
+# ---------------------------------------------------------------------------------------
+# Parse version from debian/changelog
+# ---------------------------------------------------------------------------------------
+if(EXISTS "${CMAKE_SOURCE_DIR}/debian/changelog")
+    file(READ "${CMAKE_SOURCE_DIR}/debian/changelog" CHANGELOG_CONTENT)
+    string(REGEX MATCH "deepin-anything \\(([^)]+)\\)" VERSION_MATCH "${CHANGELOG_CONTENT}")
+    if(VERSION_MATCH)
+        string(REGEX REPLACE "deepin-anything \\(([^)]+)\\)" "\\1" DEEPIN_ANYTHING_VERSION "${VERSION_MATCH}")
+        message(STATUS "Found version from debian/changelog: ${DEEPIN_ANYTHING_VERSION}")
+        # Define the version macro
+        add_compile_definitions(DEEPIN_ANYTHING_VERSION="${DEEPIN_ANYTHING_VERSION}")
+    else()
+        message(WARNING "Failed to parse version from debian/changelog")
+    endif()
+else()
+    message(WARNING "debian/changelog not found, version macro will not be defined")
+endif()
+
+# ---------------------------------------------------------------------------------------
+# Get git commit hash
+# ---------------------------------------------------------------------------------------
+find_package(Git QUIET)
+if(GIT_FOUND AND EXISTS "${CMAKE_SOURCE_DIR}/.git")
+    execute_process(
+        COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
+        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+        OUTPUT_VARIABLE DEEPIN_ANYTHING_COMMIT_HASH
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+        ERROR_QUIET
+    )
+    if(DEEPIN_ANYTHING_COMMIT_HASH)
+        message(STATUS "Found git commit hash: ${DEEPIN_ANYTHING_COMMIT_HASH}")
+        # Define the commit hash macro
+        add_compile_definitions(DEEPIN_ANYTHING_COMMIT_HASH="${DEEPIN_ANYTHING_COMMIT_HASH}")
+    else()
+        message(WARNING "Failed to get git commit hash")
+    endif()
+else()
+    if(NOT GIT_FOUND)
+        message(WARNING "Git not found, commit hash macro will not be defined")
+    else()
+        message(WARNING ".git directory not found, commit hash macro will not be defined")
+    endif()
+endif()
 
 # Find the dependencies
 find_package(QT NAMES Qt6 Qt5 CONFIG REQUIRED COMPONENTS Core)

=== debian/changelog ===
deepin-anything (7.0.23) unstable; urgency=medium

  * feat: Fix compile error and add support to kernel 6.15
  * fix: Fix fail to receive file events on a new mount namespace
  * fix: Fix fail to build on i386
  * feat: Add version and commit hash logging
  * feat: Support trace process for specific event type
  * feat: Add sysfs switch to disable event merging
  * refactor: Adjust the processing logic of directory rename events
  * fix: Fix kernel module build fail on 4.19 kernel

 -- wangrong <wangrong@uniontech.com>  Thu, 03 Jul 2025 18:52:03 +0800

=== examples/deepin-anything-monitor/debian/changelog ===
deepin-anything-monitor (0.0.1) unstable; urgency=medium

  * Initial release.

 -- Kingtous <me@kingtous.cn>  Tue, 27 Dec 2022 10:47:30 +0800

## deepin-anything 7.0.24

=== src/CMakeLists.txt ===

if(NOT CMAKE_BUILD_TYPE)
set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

message("Build type:" ${CMAKE_BUILD_TYPE})

# AddressSanitizer only:
# add_compile_options(-fsanitize=address -g)
# add_link_options(-fsanitize=address)
# Or ThreadSanitizer only:
# add_compile_options(-fsanitize=thread -g)
# add_link_options(-fsanitize=thread)

add_compile_options(-Wall -Wextra -pedantic -Werror)

add_subdirectory("server")
add_subdirectory("kernelmod")
add_subdirectory("searcher")
add_subdirectory("logger")

=== src/logger/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(deepin-anything-logger C)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)

# Find required packages
find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0 gio-2.0)
pkg_check_modules(GNL REQUIRED libnl-3.0 libnl-genl-3.0)

add_executable(deepin-anything-logger
    main.c
    event_listener.c
    event_logger.c
    file_log.c
    datatype.c
    dconfig.c
    config.c
    log.c
)

# Include directories
target_include_directories(deepin-anything-logger PUBLIC
    ${GLIB_INCLUDE_DIRS}
    ${GNL_INCLUDE_DIRS}
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../kernelmod>
)

# Link libraries
target_link_libraries(deepin-anything-logger PRIVATE
    ${GLIB_LIBRARIES}
    ${GNL_LIBRARIES}
)

install(TARGETS deepin-anything-logger
    DESTINATION bin
)

# Install dconfig meta file
install(FILES ${CMAKE_SOURCE_DIR}/assets/org.deepin.anything.logger.json DESTINATION share/dsg/configs/org.deepin.anything)

# Install systemd service file
install(FILES deepin-anything-logger.service DESTINATION lib/systemd/system)

# Build tests if enabled
option(ENABLE_TESTING "Enable testing" OFF)

if(ENABLE_TESTING)
    enable_testing()
    
    # Add tests subdirectory
    add_subdirectory(tests)
    
    # Convenience targets for running tests
    add_custom_target(check
        COMMAND ${CMAKE_CTEST_COMMAND} --verbose
        COMMENT "Running all tests"
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
    
    add_custom_target(check-verbose
        COMMAND ${CMAKE_CTEST_COMMAND} --verbose --output-on-failure
        COMMENT "Running all tests with verbose output"
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )
    
    # Coverage report target (requires debug build)
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        add_custom_target(coverage
            COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR}/tests --target coverage
            COMMENT "Generating test coverage report"
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )
    endif()

endif()

=== src/server/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,9 @@
     DESCRIPTION "A file search engine"
     LANGUAGES CXX
 )
+
+set(CMAKE_CXX_STANDARD 20)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 # ---------------------------------------------------------------------------------------
 # Parse version from debian/changelog

=== debian/changelog ===
deepin-anything (7.0.24) unstable; urgency=medium

  * refactor: Use marker file to handle invalid index
  * refactor: Improve error handling and restart mechanism
  * feat: Implement deepin-anything logger service

 -- wangrong <wangrong@uniontech.com>  Thu, 31 Jul 2025 10:18:01 +0800

## deepin-anything 7.0.31

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(deepin-anything)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

add_subdirectory(${PROJECT_SOURCE_DIR}/src)
add_subdirectory(${PROJECT_SOURCE_DIR}/config)

=== config/CMakeLists.txt ===

install(FILES pinyin.txt DESTINATION share/deepin-anything-server)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 
 add_compile_options(-Wall -Wextra -pedantic -Werror)
 
+add_subdirectory("daemon")
 add_subdirectory("server")
 add_subdirectory("kernelmod")
 add_subdirectory("searcher")

=== examples/deepin-anything-monitor/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Kingtous <me@kingtous.cn>
#
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.1)

project(deepin-anything-monitor LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(DtkDeclarative REQUIRED)

# Application
add_subdirectory(src)

=== src/daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# ---------------------------------------------------------------------------------------
# Start deepin-anything-daemon project
# ---------------------------------------------------------------------------------------
project(
    deepin-anything-daemon
    VERSION 1.0.0
    DESCRIPTION "A file search engine"
    LANGUAGES CXX
)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# ---------------------------------------------------------------------------------------
# Parse version from debian/changelog
# ---------------------------------------------------------------------------------------
if(EXISTS "${CMAKE_SOURCE_DIR}/debian/changelog")
    file(READ "${CMAKE_SOURCE_DIR}/debian/changelog" CHANGELOG_CONTENT)
    string(REGEX MATCH "deepin-anything \\(([^)]+)\\)" VERSION_MATCH "${CHANGELOG_CONTENT}")
    if(VERSION_MATCH)
        string(REGEX REPLACE "deepin-anything \\(([^)]+)\\)" "\\1" DEEPIN_ANYTHING_VERSION "${VERSION_MATCH}")
        message(STATUS "Found version from debian/changelog: ${DEEPIN_ANYTHING_VERSION}")
        # Define the version macro
        add_compile_definitions(DEEPIN_ANYTHING_VERSION="${DEEPIN_ANYTHING_VERSION}")
    else()
        message(WARNING "Failed to parse version from debian/changelog")
    endif()
else()
    message(WARNING "debian/changelog not found, version macro will not be defined")
endif()

# ---------------------------------------------------------------------------------------
# Get git commit hash
# ---------------------------------------------------------------------------------------
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${CMAKE_SOURCE_DIR}/.git")
    execute_process(
        COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE DEEPIN_ANYTHING_COMMIT_HASH
        OUTPUT_STRIP_TRAILING_WHITESPACE
        ERROR_QUIET
    )
    if(DEEPIN_ANYTHING_COMMIT_HASH)
        message(STATUS "Found git commit hash: ${DEEPIN_ANYTHING_COMMIT_HASH}")
        # Define the commit hash macro
        add_compile_definitions(DEEPIN_ANYTHING_COMMIT_HASH="${DEEPIN_ANYTHING_COMMIT_HASH}")
    else()
        message(WARNING "Failed to get git commit hash")
    endif()
else()
    if(NOT GIT_FOUND)
        message(WARNING "Git not found, commit hash macro will not be defined")
    else()
        message(WARNING ".git directory not found, commit hash macro will not be defined")
    endif()
endif()

# Find the dependencies
find_package(QT NAMES Qt6 Qt5 CONFIG REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} CONFIG REQUIRED Core)
find_package(PkgConfig REQUIRED)
find_package(Boost REQUIRED COMPONENTS system)
find_package(spdlog REQUIRED)
pkg_check_modules(GNL REQUIRED libnl-3.0 libnl-genl-3.0)
pkg_check_modules(MOUNT REQUIRED mount IMPORTED_TARGET)
pkg_check_modules(LUCENE REQUIRED liblucene++)
pkg_check_modules(LUCENE_CONTRIB REQUIRED liblucene++-contrib)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(GMODULE REQUIRED gmodule-2.0)

# Found all source files
file(GLOB_RECURSE SOURCE_FILES "${PROJECT_SOURCE_DIR}/src/*.cpp" "${PROJECT_SOURCE_DIR}/src/*.c")
list(LENGTH SOURCE_FILES SRC_FILES_SIZE)
message(STATUS "Found ${SRC_FILES_SIZE} source files of deepin-anything-daemon")
foreach(source_file ${SOURCE_FILES})
    message(STATUS "  ${source_file}")
endforeach()

# Define a shared library
add_executable(${PROJECT_NAME})

target_sources(${PROJECT_NAME} PRIVATE ${SOURCE_FILES})

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../kernelmod>
    # $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../3rdparty>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    ${LUCENE_INCLUDE_DIRS}
    ${GNL_INCLUDE_DIRS}
    ${MOUNT_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${GMODULE_INCLUDE_DIRS}
    ${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PUBLIC
    ${LUCENE_LIBRARIES}
    ${LUCENE_CONTRIB_LIBRARIES}
    ${GNL_LIBRARIES}
    ${MOUNT_LIBRARIES}
    ${Boost_LIBRARIES}
    pthread
    stdc++fs
    spdlog::spdlog
    ${GLIB_LIBRARIES}
    ${GIO_LIBRARIES}
    ${GMODULE_LIBRARIES}
    Qt${QT_VERSION_MAJOR}::Core
)

target_compile_options(${PROJECT_NAME} PRIVATE -Wall -Werror -Wextra)
target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_17)

configure_file ("${PROJECT_NAME}.pc.in" "${PROJECT_NAME}.pc" @ONLY)
install(TARGETS ${PROJECT_NAME} DESTINATION libexec)
install(FILES deepin-anything-daemon.service DESTINATION lib/systemd/user)

# Install dconfig meta file
install(FILES ${CMAKE_SOURCE_DIR}/assets/org.deepin.anything.json DESTINATION share/dsg/configs/org.deepin.anything)

=== src/kernelmod/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project(vfs_monitor)

# Version
if (NOT PROJECT_VERSION)
    set(PROJECT_VERSION "0.0")
endif()

set(package_name "deepin-anything-${PROJECT_VERSION}")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -O3")

 # Set the source files
# set(SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*)

FILE(GLOB SOURCES
    "*.h"
    "*.c"
    )

FILE(GLOB SRC_FILES
    "*.h"
    "*.c"
    "Makefile"
    "CMakeLists.txt"
    )

 # Set the install directory
set(INSTALL_DIR /usr/src/${package_name})

 # Create the module target
# add_library(${PROJECT_NAME} SHARED ${SOURCES})

 # Set the install target
# install(TARGETS ${PROJECT_NAME} DESTINATION ${INSTALL_DIR})

# file(COPY kernelmod/* DESTINATION ${CMAKE_INSTALL_LIBDIR}/usr/src/deepin-anything-${VERSION})

 # Create the DKMS configuration file
configure_file(dkms.conf.in dkms.conf @ONLY)

 # Install the DKMS configuration file
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dkms.conf DESTINATION ${INSTALL_DIR})

 # Create the DKMS deb package install file
configure_file(
    deepin-anything-dkms.dkms.in
    deepin-anything-dkms.dkms
    @ONLY
)

message("CMAKE_CURRENT_BINARY_DIR:" ${CMAKE_CURRENT_BINARY_DIR})

 # Install the DKMS file into debian dir
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/deepin-anything-dkms.dkms DESTINATION ../..)

 # Install all source files
 install(FILES ${SRC_FILES} DESTINATION ${INSTALL_DIR})

  # Install the module conf file
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/anything.conf DESTINATION /usr/lib/modules-load.d)

=== src/kernelmod/Makefile ===
obj-m += vfs_monitor.o
vfs_monitor-objs := arg_extractor.o event_merge.o event.o module.o \
		    vfs_kretprobes.o vfs_fsnotify.o vfs_genl.o vfs_sysfs.o \
		    vfs_trace_process.o
ccflags-y := -std=gnu99 -Wall -O3
cwd := $(shell pwd)

kdir := /lib/modules/$(shell uname -r)/build

all:
	make -C ${kdir} M=$(cwd) modules

clean:
	make -C ${kdir} M=$(cwd) clean

=== src/logger/CMakeLists.txt ===
--- 
+++ 
@@ -34,9 +34,7 @@
     ${GNL_LIBRARIES}
 )
 
-install(TARGETS deepin-anything-logger
-    DESTINATION bin
-)
+install(TARGETS deepin-anything-logger DESTINATION libexec)
 
 # Install dconfig meta file
 install(FILES ${CMAKE_SOURCE_DIR}/assets/org.deepin.anything.logger.json DESTINATION share/dsg/configs/org.deepin.anything)

=== src/searcher/CMakeLists.txt ===
--- 
+++ 
@@ -16,8 +16,8 @@
 add_executable(deepin-anything-searcher
     main.cpp
     searcher.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/../server/src/analyzers/chineseanalyzer.cpp
-    ${CMAKE_CURRENT_SOURCE_DIR}/../server/src/analyzers/chinesetokenizer.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/../daemon/src/analyzers/chineseanalyzer.cpp
+    ${CMAKE_CURRENT_SOURCE_DIR}/../daemon/src/analyzers/chinesetokenizer.cpp
 )
 
 # Include directories
@@ -25,7 +25,7 @@
     ${GLIB_INCLUDE_DIRS}
     ${LUCENE_INCLUDE_DIRS}
     ${LUCENE_CONTRIB_INCLUDE_DIRS}
-    ${CMAKE_CURRENT_SOURCE_DIR}/../server/include
+    ${CMAKE_CURRENT_SOURCE_DIR}/../daemon/include
 )
 
 # Link libraries

=== src/server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(deepin-anything-server)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(GIO_UNIX REQUIRED gio-unix-2.0)
pkg_check_modules(MOUNT REQUIRED mount IMPORTED_TARGET)

add_executable(${PROJECT_NAME} main.c)

target_include_directories(${PROJECT_NAME} PRIVATE
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${GIO_UNIX_INCLUDE_DIRS}
    ${MOUNT_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    ${GLIB_LIBRARIES}
    ${GIO_LIBRARIES}
    ${GIO_UNIX_LIBRARIES}
    ${MOUNT_LIBRARIES}
)

install(TARGETS ${PROJECT_NAME} DESTINATION libexec)
# installed by debhelper
# install(FILES deepin-anything-server.service DESTINATION lib/systemd/system)

=== src/logger/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2025 UOS Technology Co., Ltd.
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.10)

# 启用测试
enable_testing()

# 设置测试相关的编译选项
if(ENABLE_TESTING)
    message(STATUS "启用单元测试构建")
    
    # 添加覆盖率编译选项
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        add_compile_options(--coverage -fprofile-arcs -ftest-coverage)
        add_link_options(--coverage)
    endif()
    
    # 查找测试依赖
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(GLIB2 REQUIRED glib-2.0)
    pkg_check_modules(GIO2 REQUIRED gio-2.0)
    pkg_check_modules(LIBNL REQUIRED libnl-3.0 libnl-genl-3.0)
    
    # 设置测试包含目录
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)
    include_directories(${GLIB2_INCLUDE_DIRS})
    include_directories(${GIO2_INCLUDE_DIRS})
    include_directories(${LIBNL_INCLUDE_DIRS})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../kernelmod)
    
    # 设置测试链接库
    set(TEST_LIBRARIES 
        ${GLIB2_LIBRARIES}
        ${GIO2_LIBRARIES}
        ${LIBNL_LIBRARIES}
        m
        pthread
    )
    
    # 设置测试源文件目录
    set(LOGGER_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/..)
    
    # 通用测试源文件
    set(COMMON_TEST_SOURCES
        ${LOGGER_SOURCE_DIR}/log.c
        ${LOGGER_SOURCE_DIR}/datatype.c
    )
    
    # 事件日志模块测试
    add_executable(test_event_logger
        test_event_logger.c
        ${LOGGER_SOURCE_DIR}/event_logger.c
        ${LOGGER_SOURCE_DIR}/file_log.c
        ${COMMON_TEST_SOURCES}
    )
    target_link_libraries(test_event_logger ${TEST_LIBRARIES})
    add_test(NAME EventLoggerTest COMMAND test_event_logger)
    
    # 文件日志模块测试
    add_executable(test_file_log
        test_file_log.c
        ${LOGGER_SOURCE_DIR}/file_log.c
        ${COMMON_TEST_SOURCES}
    )
    target_link_libraries(test_file_log ${TEST_LIBRARIES})
    add_test(NAME FileLogTest COMMAND test_file_log)
    
    # 设置测试环境变量
    set_tests_properties(EventLoggerTest PROPERTIES
        ENVIRONMENT "G_MESSAGES_DEBUG=all"
    )
    set_tests_properties(FileLogTest PROPERTIES
        ENVIRONMENT "G_MESSAGES_DEBUG=all"
    )
    
    # 覆盖率报告目标
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        find_program(GCOV_PATH gcov)
        find_program(LCOV_PATH lcov)
        find_program(GENHTML_PATH genhtml)
        
        if(LCOV_PATH AND GENHTML_PATH)
            # 清理覆盖率数据
            add_custom_target(coverage_clean
                COMMAND ${LCOV_PATH} --directory . --zerocounters
                COMMENT "清理覆盖率计数器"
            )
            
            # 生成覆盖率报告
            add_custom_target(coverage
                # 运行测试
                COMMAND ${CMAKE_CTEST_COMMAND} --verbose
                
                # 收集覆盖率数据
                COMMAND ${LCOV_PATH} --directory . --capture --output-file coverage.info
                
                # 过滤系统文件和测试文件
                COMMAND ${LCOV_PATH} --remove coverage.info 
                    '/usr/*' 
                    '*/tests/*'
                    '*/build/*'
                    --output-file coverage_filtered.info
                
                # 生成HTML报告
                COMMAND ${GENHTML_PATH} coverage_filtered.info --output-directory coverage_html
                
                COMMENT "生成测试覆盖率报告"
                DEPENDS coverage_clean
            )
            
            message(STATUS "覆盖率报告将生成到 coverage_html/ 目录")
        else()
            message(WARNING "未找到lcov或genhtml，无法生成覆盖率报告")
        endif()
    endif()
    
    # 内存泄漏检测
    find_program(VALGRIND_PATH valgrind)
    if(VALGRIND_PATH)
        add_custom_target(memcheck
            COMMAND ${CMAKE_CTEST_COMMAND} 
                --test-action memcheck
                --force-new-ctest-process
                --output-on-failure
            COMMENT "使用Valgrind进行内存泄漏检测"
        )
        message(STATUS "可使用 'make memcheck' 进行内存泄漏检测")
    endif()
    
endif()

# 便利目标
add_custom_target(all_tests
    DEPENDS 
        test_event_logger
        test_file_log
    COMMENT "构建所有测试"
)

# 显示测试统计信息
add_custom_target(test_stats
    COMMAND echo "=== 测试统计信息 ==="
    COMMAND echo "事件日志测试: test_event_logger"
    COMMAND echo "文件日志测试: test_file_log"
    COMMAND echo "==================="
    COMMENT "显示测试模块信息"
)

=== examples/deepin-anything-monitor/src/maincomponentplugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Kingtous <me@kingtous.cn>
#
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.1)

set(MAINCOMPONENT_LIB_NAME dtkqml-${CMAKE_PROJECT_NAME})

###! maincomponent 中可以添加应用的第三方依赖、注册
###! 应用的c++和qml类型、进行耗时计算和加载等等。
###! 但为了最大程度的启动（创建）组件，请保证在 main.qml
###! 中 AppLoader 结构的正确性，将互相独立的组件独立成
###! 不同的 Component 进行并发加载。

# Set sources
set(MAINCOMPONENNT_SRC
    maincomponentplugin.cpp
    dagenlclient.cpp
    vfsevent.cpp
    blockdevicemodel.cpp
    blockdeviceitem.cpp
    vfseventmodel.cpp
    mountinfo.cpp
    )

# Find the Qt5Quick library
find_package(Qt5Quick CONFIG REQUIRED)
find_package(Qt5QuickCompiler REQUIRED)
find_package(Qt5 COMPONENTS Test REQUIRED)

# Find libnl-genl-3.0
find_package(PkgConfig REQUIRED)
pkg_search_module(NL_GENL REQUIRED libnl-genl-3.0)
include_directories(${NL_GENL_INCLUDE_DIRS})
message(STATUS "found libnl-genl-3.0 at ${NL_GENL_INCLUDE_DIRS}")

qtquick_compiler_add_resources(MAINCOMPONENT_RCC_SOURCES maincomponent.qrc)

# 保证 maincomponentplugin 目录下头文件全局可见
include_directories(src/maincomponentplugin)

# Add LIB
add_library(${MAINCOMPONENT_LIB_NAME} SHARED
    ${MAINCOMPONENNT_SRC}
    ${MAINCOMPONENT_RCC_SOURCES}
    )

# 由于 LIB 程序为本项目的功能实现部分，需要用到的第三方库都需要在此处添加。
target_link_libraries(${MAINCOMPONENT_LIB_NAME}
    Qt5::Quick
    Qt5::Test
    ${DtkDeclarative_LIBRARIES}
    ${NL_GENL_LIBRARIES}
    )

# 测试程序
set(TEST_NAME deepin-anything-genl-test)
add_executable(${TEST_NAME} test.cpp)
target_link_libraries(${TEST_NAME} ${NL_GENL_LIBRARIES})

# Add install rule
install(TARGETS ${MAINCOMPONENT_LIB_NAME} DESTINATION ${DTK_QML_APP_PLUGIN_PATH})

=== debian/changelog ===
deepin-anything (7.0.31) unstable; urgency=medium

  * fix: Fix deepin-anything-daemon coredump

 -- wangrong <wangrong@uniontech.com>  Thu, 23 Oct 2025 14:27:25 +0800

deepin-anything (7.0.30) unstable; urgency=medium

  * fix: Fix daemon is always in loading state

 -- wangrong <wangrong@uniontech.com>  Fri, 10 Oct 2025 14:57:21 +0800

deepin-anything (7.0.29) unstable; urgency=medium

  * refactor: Rework the initial index scanning mechanism

 -- wangrong <wangrong@uniontech.com>  Tue, 16 Sep 2025 14:55:52 +0800

deepin-anything (7.0.28) unstable; urgency=medium

  * update version to 7.0.28

 -- wangrong <wangrong@uniontech.com>  Thu, 11 Sep 2025 20:30:53 +0800

deepin-anything (7.0.27) unstable; urgency=medium

  * fix: Fix deepin-anything-daemon core dump for uninitialized index_status_

 -- wangrong <wangrong@uniontech.com>  Thu, 04 Sep 2025 16:48:50 +0800

deepin-anything (7.0.26) unstable; urgency=medium

  * feat: Add pinyin acronym to file index
  * feat: Refactor VFS unnamed device file handling
  * feat: Update pinyin processing and indexing
  * fix: Fix fail to create symbolic links for index entry point

 -- wangrong <wangrong@uniontech.com>  Tue, 02 Sep 2025 18:48:01 +0800

deepin-anything (7.0.25) unstable; urgency=medium

  * refactor: Update installation paths for deepin-anything services
  * fix: Fix insufficient index storage space
  * refactor: Remove deepin-anything server and related service files
  * refactor: Adjust project structure
  * feat: Add deepin-anything-server service
  * refactor: Allow handle file events from all devices
  * feat: Adapt to long file name system
  * feat: Add formatted modify time field to file records
  * feat: Ensure .cache in blacklist
  * feat: Enhance mount chain validation logic

 -- wangrong <wangrong@uniontech.com>  Tue, 26 Aug 2025 21:10:14 +0800

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --parallel --with dkms,systemd

override_dh_auto_configure:
	dh_auto_configure -Scmake -- \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DHOST_MULTIARCH="$(DEB_HOST_MULTIARCH)"

override_dh_installinit:
	true

override_dh_systemd_enable:
	dh_systemd_enable -pdeepin-anything-server deepin-anything-server.service

override_dh_systemd_start:
	dh_systemd_start -pdeepin-anything-server deepin-anything-server.service

override_dh_auto_clean:

## deepin-anything 7.0.32

=== debian/changelog ===
deepin-anything (7.0.32) unstable; urgency=medium

  * fix: Fix deepin-anything-daemon coredump

 -- wangrong <wangrong@uniontech.com>  Tue, 11 Nov 2025 21:09:59 +0800

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 export DH_VERBOSE=1
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+export DEB_LDFLAGS_APPEND = -Wl,-z,now
 
 %:
 	dh $@ --parallel --with dkms,systemd
